/*
 * This file and its contents are supplied under the terms of the
 * Common Development and Distribution License ("CDDL"), version 1.0.
 * You may only use this file in accordance with the terms of version
 * 1.0 of the CDDL.
 *
 * A full copy of the text of the CDDL should have accompanied this
 * source.  A copy of the CDDL is also available via the Internet at
 * http://www.illumos.org/license/CDDL.
 */

/*
 * Copyright 2013 Damian Bogel.  All rights reserved.
 */

#ifndef _FSH_IMPL_H
#define	_FSH_IMPL_H

#include <sys/pathname.h>
#include <sys/types.h>
#include <sys/vfs.h>
#include <sys/vnode.h>

#ifdef __cplusplus
extern "C" {
#endif

struct fsh_fsrecord;

/* API for vnode.c and vfs.c only */
/* vnode.c */
extern int fsh_open(vnode_t **vpp, int mode, cred_t *cr, caller_context_t *ct);
extern int fsh_close(vnode_t *vp, int flag, int count, offset_t offset,
		cred_t *cr, caller_context_t *ct);
extern int fsh_read(vnode_t *vp, uio_t *uiop, int ioflag, cred_t *cr,
		caller_context_t *ct);
extern int fsh_write(vnode_t *vp, uio_t *uiop, int ioflag, cred_t *cr,
		caller_context_t *ct);

/* vfs.c */
extern int fsh_mount(vfs_t *vfsp, vnode_t *mvp, struct mounta *uap,
		cred_t *cr);
extern int fsh_unmount(vfs_t *vfsp, int flag, cred_t *cr);
extern int fsh_root(vfs_t *vfsp, vnode_t **vpp);
extern int fsh_statfs(vfs_t *vfsp, statvfs64_t *sp);
extern int fsh_vget(vfs_t *vfsp, vnode_t **vpp, fid_t *fidp);

extern void fsh_exec_create_callbacks(vfs_t *vfsp);
extern void fsh_exec_destroy_callbacks(vfs_t *vfsp);

extern struct fsh_fsrecord * fsh_fsrec_create();
extern void fsh_fsrec_destroy(struct fsh_fsrecord *fsrecp);

#ifdef __cplusplus
}
#endif

#endif /* _FSH_IMPL_H */
